<template>
  <div class="one-question skiptranslate">
    
    <h2 class="text-dark">Question {{ listQuestId && listQuestId.length }}</h2>
    <p class="question-text text-dark py-4">
      {{ questData && questData.description }}<br />
      <span v-if="questData && questData.type == 2" class="fw-bold fs-4"
        >X: No - O: Yes</span>
      <span v-if="questData && questData.type == 0" class="fw-bold fs-4"
        >Choose a correct answer</span>
    </p>

    <div
      class="action-wrap d-flex justify-content-between mb-3 px-lg-4 flex-wrap"
      v-if="questData && questData.type == 2"
    >
      <button
        class="btn btn-danger fw-bolder"
        style="font-size: 22px; width: 45%"
        @click="chooseAnswer('x', $event)"
      >
        X
      </button>
      <button
        class="btn btn-secondary fw-bolder"
        style="opacity: 0.8; font-size: 22px; width: 45%"
        @click="chooseAnswer('o', $event)"
      >
        O
      </button>
    </div>
    <div
      class="action-wrap d-flex justify-content-between mb-3 px-lg-4 flex-wrap"
      v-else-if="questData && (questData.type == 0 || type === 'survey')"
    >
      <button
        v-for="(item, ind) in listAnswer"
        :key="ind"
        class="btn btn-secondary fw-bolder mb-4"
        style="opacity: 0.8; font-size: 22px; width: 45%"
        @click="chooseAnswer(item.key, $event)"
      >
        {{ item.key }}.
        {{ item.content }}
      </button>
      <!-- <div class="w-100 py-3"></div> -->
    </div>
  </div>
</template>

<script>
export default {
  props: {
    type: String,
    questData: Object,
    listQuestId: Array,
  },
  data() {
    return {
      onCallService: false,
    };
  },
  computed: {
    listAnswer() {
      try {
        let answer = this.questData && this.questData.answer;
        answer = JSON.parse(answer);
        answer = answer.filter((item) => {
          if (item.content) {
            return item;
          }
        });
        return answer;
      } catch (error) {
        console.log(error);
        return [];
      }
    },
  },
  watch: {
    questData: {
      deep: true,
      handler(val, oldVal) {
        if (JSON.stringify(val) === JSON.stringify(oldVal)) {
          this.onCallService = true;
          return;
        }
        this.onCallService = false;
      },
    },
  },
  methods: {
    chooseAnswer(content, event) {
      // Remove focus style
      event.target.blur();

      if (this.onCallService) {
        console.log("on call");
        return;
      }
      if (!this.questData || !this.questData.id) return;
      let audio = document.getElementById(`audio-${this.listQuestId.length}`)
      audio.play()
      this.$emit("choose-answer", { id: this.questData.id, answered: content });
    },
  },
};
</script>

<style scoped></style>
